"use strict";

/*
 * @Author: Yuki
 * @Date: 2021-04-12 10:54:42
 * @LastEditTime: 2021-05-10 11:49:12
 * @LastEditors: Please set LastEditors
 * @Description: 加入Socket.io
 * @FilePath: \npm-tools\yuki-next-server-express\src\index.js
 */
module.exports = function server(_ref) {
  var app = _ref.app,
      port = _ref.port,
      devProxy = _ref.devProxy,
      handlers = _ref.handlers;

  var express = require('express');

  var cookieParser = require('cookie-parser');

  var _require = require('url'),
      parse = _require.parse;

  var _require2 = require('http-proxy-middleware'),
      proxyMiddleware = _require2.createProxyMiddleware;

  var path = require('path');

  var fs = require('fs');

  var serverPort = parseInt(process.env.PORT, 10) || port || 3000;
  var handle = app.getRequestHandler();

  var serverAllFunc = function serverAllFunc(req, res) {
    var parsedUrl = parse(req.url, true);
    handle(req, res, parsedUrl);
  };

  if (handlers) serverAllFunc = handlers;
  app.prepare().then(function () {
    var server = express();

    var httpServer = require('http').createServer(server);

    if (devProxy) Object.keys(devProxy).forEach(function (context) {
      server.use(proxyMiddleware(context, devProxy[context]));
    });
    server.use(express.json());
    server.use(cookieParser());
    server.use(express.urlencoded({
      extended: true
    })); //调用中间件

    var routeNames = fs.readdirSync(path.resolve(process.cwd(), './server/routes')).map(function (routeName) {
      return routeName.split('.')[0];
    });
    routeNames.forEach(function (routeName) {
      var filenames = fs.readdirSync(path.resolve(process.cwd(), "./server/routes/".concat(routeName))).map(function (filename) {
        return filename.split('.')[0];
      });
      filenames.forEach(function (filename) {
        server.use("/".concat(routeName, "/").concat(filename), require(path.resolve(process.cwd(), "./server/routes/".concat(routeName, "/").concat(filename))));
      });
    });
    server.all('*', serverAllFunc); // socket

    if (fs.existsSync(path.resolve(process.cwd(), './server/socket/index.js'))) {
      var io = require('socket.io')(httpServer, {
        cors: true
      });

      var socket = require(path.resolve(process.cwd(), './server/socket'));

      socket(io);
    }

    httpServer.listen(serverPort, function (err) {
      if (err) throw err;
      console.log("> Ready on http://localhost:".concat(serverPort));
    });
  })["catch"](function (err) {
    console.log('An error occurred, unable to start the server');
    console.log(err);
  });
};
//# sourceMappingURL=index.js.map